import { __assign, __awaiter, __generator } from "tslib";
import { isLoaderRequestElement, FetchHookTypes } from "../../../types";
import { ModulePrefix } from "../../../";
import ResolveRoute from '../../../util/ResolveRoute';
var buildAsyncData = function (loaderRequest, fht) {
    if (fht === void 0) { fht = FetchHookTypes.AsyncData; }
    return function (_a) {
        var store = _a.store, route = _a.route;
        return __awaiter(this, void 0, void 0, function () {
            var resolvedLoaderRequest, isPost, contentType, resolvedLoaderRequest, dataName, response, _i, loaderRequest_1, request, localResponse;
            var _b, _c;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        if (!(typeof loaderRequest === "string")) return [3 /*break*/, 2];
                        resolvedLoaderRequest = ResolveRoute(loaderRequest, route);
                        return [4 /*yield*/, store.dispatch(ModulePrefix + "_post/load", {
                                slug: resolvedLoaderRequest,
                                type: "pages",
                                embed: false
                            })];
                    case 1:
                        _d.sent();
                        if (fht === FetchHookTypes.AsyncData) {
                            return [2 /*return*/, (_b = {},
                                    _b[resolvedLoaderRequest] = store.state[ModulePrefix + "_post"].types.pages[resolvedLoaderRequest]
                                        ? store.state[ModulePrefix + "_post"].types.pages[resolvedLoaderRequest]
                                        : null,
                                    _b)];
                        }
                        return [3 /*break*/, 10];
                    case 2:
                        if (!isLoaderRequestElement(loaderRequest)) return [3 /*break*/, 4];
                        isPost = "type" in loaderRequest && loaderRequest.type;
                        contentType = isPost ? loaderRequest.type : "pages";
                        resolvedLoaderRequest = ResolveRoute(loaderRequest.slug, route);
                        return [4 /*yield*/, store.dispatch(ModulePrefix + "_post/load", {
                                slug: resolvedLoaderRequest,
                                type: contentType,
                                embed: loaderRequest.hasOwnProperty('embed')
                            })];
                    case 3:
                        _d.sent();
                        if (fht === FetchHookTypes.AsyncData) {
                            dataName = "dataName" in loaderRequest && loaderRequest.dataName
                                ? loaderRequest.dataName
                                : resolvedLoaderRequest;
                            return [2 /*return*/, (_c = {},
                                    _c[dataName] = store.state[ModulePrefix + "_post"].types[contentType][resolvedLoaderRequest]
                                        ? store.state[ModulePrefix + "_post"].types[contentType][resolvedLoaderRequest]
                                        : null,
                                    _c)];
                        }
                        return [3 /*break*/, 10];
                    case 4:
                        if (!Array.isArray(loaderRequest)) return [3 /*break*/, 9];
                        response = {};
                        _i = 0, loaderRequest_1 = loaderRequest;
                        _d.label = 5;
                    case 5:
                        if (!(_i < loaderRequest_1.length)) return [3 /*break*/, 8];
                        request = loaderRequest_1[_i];
                        if (typeof request !== "string" && !isLoaderRequestElement(request)) {
                            throw new Error("FetchHookTypeVoidAsyncData: Bad loaderRequest");
                        }
                        return [4 /*yield*/, buildAsyncData
                                .call(this, request, FetchHookTypes.AsyncData)
                                .call(this, { store: store })];
                    case 6:
                        localResponse = _d.sent();
                        response = __assign(__assign({}, response), localResponse);
                        _d.label = 7;
                    case 7:
                        _i++;
                        return [3 /*break*/, 5];
                    case 8: return [2 /*return*/, response];
                    case 9: throw new Error("FetchHookTypeVoidAsyncData: loaderRequest cannot be " +
                        typeof loaderRequest);
                    case 10: return [2 /*return*/];
                }
            });
        });
    };
};
export default buildAsyncData;
//# sourceMappingURL=AsyncData.js.map