import { __awaiter, __generator } from "tslib";
import { ModulePrefix } from "../../index";
import { post } from "../../store/post";
import { menu } from "../../store/menu";
import { meta } from "../../store/meta";
import { config } from "../../store/config";
import { SET_CONFIG } from "../../store/config/mutation-types";
export var registerModules = function (store, useMenu) {
    if (useMenu === void 0) { useMenu = true; }
    if (useMenu)
        store.registerModule(ModulePrefix + "_menu", menu);
    store.registerModule(ModulePrefix + "_meta", meta);
    store.registerModule(ModulePrefix + "_post", post);
    store.registerModule(ModulePrefix + "_config", config);
};
export var loadBase = function (dispatch, menuSlugs) { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (!!menuSlugs) return [3 /*break*/, 2];
                return [4 /*yield*/, dispatch(ModulePrefix + "_meta/load")];
            case 1:
                _a.sent();
                return [3 /*break*/, 4];
            case 2: return [4 /*yield*/, Promise.all([
                    dispatch(ModulePrefix + "_menu/load", {
                        menuSlugs: menuSlugs
                    }),
                    dispatch(ModulePrefix + "_meta/load")
                ])];
            case 3:
                _a.sent();
                _a.label = 4;
            case 4: return [2 /*return*/];
        }
    });
}); };
export var setConfig = function (commit, config) {
    commit(ModulePrefix + "_config/" + SET_CONFIG, config);
};
//# sourceMappingURL=store.js.map