import { __assign, __awaiter, __generator } from "tslib";
import { ModulePrefix } from './../../index';
import axios from "axios";
import * as types from "./mutation-types";
import { UrlCreator } from "../../util/UrlCreator";
var typeBaseUrl = "/wp-json/menus/v1/menus";
export var actions = {
    load: function (_a, _b) {
        var rootState = _a.rootState, commit = _a.commit, state = _a.state;
        var menuSlugs = _b.menuSlugs;
        return __awaiter(this, void 0, void 0, function () {
            var config, prefix, base, fixUrls, requests, _i, menuSlugs_1, slug, hasMenu, response, hasMenu, response, firstResponse, slugs, requests, _c, slugs_1, slug, hasMenu, response, err_1;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        if (menuSlugs === false) {
                            return [2 /*return*/];
                        }
                        config = rootState[ModulePrefix + "_config"];
                        if (config.requestPrefix) {
                            prefix = config.requestPrefix;
                            if (prefix.endsWith("/")) {
                                prefix = prefix.substring(0, -1);
                            }
                            if (prefix.startsWith("/")) {
                                prefix = prefix.substr(1);
                            }
                            typeBaseUrl = "/" + prefix + typeBaseUrl;
                        }
                        base = new UrlCreator(config.url, [typeBaseUrl]);
                        fixUrls = function (itemsBefore) {
                            var fixedItems = [];
                            // If itemsBefore is Object, we have to convert it to array
                            var items = Array.isArray(itemsBefore)
                                ? itemsBefore
                                : Object.values(itemsBefore);
                            var _loop_1 = function (item) {
                                var prefix = item.object == "page" ? "page" : "post";
                                fixedItems.push(__assign(__assign({}, item), { url: item.url.replace(config.url, function (k) {
                                        return config.url.substr(-1) === "/" ? "/" + prefix + "/" : prefix + "/";
                                    }) }));
                            };
                            for (var _i = 0, items_1 = items; _i < items_1.length; _i++) {
                                var item = items_1[_i];
                                _loop_1(item);
                            }
                            return fixedItems;
                        };
                        _d.label = 1;
                    case 1:
                        _d.trys.push([1, 9, , 10]);
                        if (!Array.isArray(menuSlugs)) return [3 /*break*/, 3];
                        requests = [];
                        for (_i = 0, menuSlugs_1 = menuSlugs; _i < menuSlugs_1.length; _i++) {
                            slug = menuSlugs_1[_i];
                            hasMenu = state.menu[slug];
                            if (hasMenu) {
                                if (config.debugger) {
                                    console.log("[VueWordpress][Debugger] Omits " + slug + " menu because it has been fetched yet");
                                }
                                continue;
                            }
                            base.addAtTheEnd(slug);
                            requests.push(axios.get(base.url));
                            base.removeFromTheEnd();
                        }
                        return [4 /*yield*/, Promise.all(requests)];
                    case 2:
                        response = _d.sent();
                        response.forEach(function (c) {
                            commit(types.SET_MENU_CONTENT, {
                                data: __assign(__assign({}, c.data), { items: fixUrls(c.data.items) }),
                                slotName: c.data.slug
                            });
                        });
                        return [3 /*break*/, 8];
                    case 3:
                        if (!(typeof menuSlugs === "string")) return [3 /*break*/, 5];
                        hasMenu = state.menu[menuSlugs];
                        if (hasMenu) {
                            if (config.debugger) {
                                console.log("[VueWordpress][Debugger] Omits " + menuSlugs + " menu because it has been fetched yet");
                            }
                            return [2 /*return*/];
                        }
                        base.addAtTheEnd(menuSlugs);
                        return [4 /*yield*/, axios.get(base.url)];
                    case 4:
                        response = _d.sent();
                        commit(types.SET_MENU_CONTENT, {
                            data: __assign(__assign({}, response.data), { items: fixUrls(response.data.items) }),
                            slotName: menuSlugs
                        });
                        return [3 /*break*/, 8];
                    case 5:
                        if (!(menuSlugs === true)) return [3 /*break*/, 8];
                        return [4 /*yield*/, axios.get(base.url)];
                    case 6:
                        firstResponse = _d.sent();
                        slugs = firstResponse.data.map(function (v) { return v.slug; });
                        requests = [];
                        for (_c = 0, slugs_1 = slugs; _c < slugs_1.length; _c++) {
                            slug = slugs_1[_c];
                            hasMenu = state.menu[slug];
                            if (hasMenu) {
                                if (config.debugger) {
                                    console.log("[VueWordpress][Debugger] Omits " + slug + " menu because it has been fetched yet");
                                }
                                continue;
                            }
                            base.addAtTheEnd(slug);
                            requests.push(axios.get(base.url));
                            base.removeFromTheEnd();
                        }
                        return [4 /*yield*/, Promise.all(requests)];
                    case 7:
                        response = _d.sent();
                        response.forEach(function (c) {
                            commit(types.SET_MENU_CONTENT, {
                                data: __assign(__assign({}, c.data), { items: fixUrls(c.data.items) }),
                                slotName: c.data.slug
                            });
                        });
                        _d.label = 8;
                    case 8: return [3 /*break*/, 10];
                    case 9:
                        err_1 = _d.sent();
                        console.error(err_1);
                        return [3 /*break*/, 10];
                    case 10: return [2 /*return*/];
                }
            });
        });
    }
};
//# sourceMappingURL=actions.js.map