import { __awaiter, __generator } from "tslib";
import { ModulePrefix } from './../../index';
import axios from "axios";
import * as types from "./mutation-types";
import { UrlCreator } from "../../util/UrlCreator";
var typeBaseUrl = "/wp-json";
export var actions = {
    load: function (_a) {
        var rootState = _a.rootState, commit = _a.commit, state = _a.state;
        return __awaiter(this, void 0, void 0, function () {
            var config, prefix, base, hasMeta, data, err_1;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        config = rootState[ModulePrefix + "_config"];
                        if (config.requestPrefix) {
                            prefix = config.requestPrefix;
                            if (prefix.endsWith("/")) {
                                prefix = prefix.substring(0, -1);
                            }
                            if (prefix.startsWith("/")) {
                                prefix = prefix.substr(1);
                            }
                            typeBaseUrl = "/" + prefix + typeBaseUrl;
                        }
                        base = new UrlCreator(config.url, [typeBaseUrl]);
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 3, , 4]);
                        hasMeta = !!Object.keys(state.meta).length;
                        if (hasMeta) {
                            if (config.debugger) {
                                console.log('[VueWordpress][Debugger] Omits fetching meta because it has been fetched yet');
                            }
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, axios.get(base.url)];
                    case 2:
                        data = (_b.sent()).data;
                        commit(types.SET_META_CONTENT, {
                            data: {
                                name: data.name,
                                description: data.description,
                                url: data.url,
                                home: data.home,
                                gmt_offset: data.gmt_offset,
                                timezone_string: data.timezone_string
                            }
                        });
                        return [3 /*break*/, 4];
                    case 3:
                        err_1 = _b.sent();
                        console.error(err_1);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    }
};
//# sourceMappingURL=actions.js.map