import { __awaiter, __generator } from "tslib";
import { ModulePrefix } from './../../index';
import axios from "axios";
import * as types from "./mutation-types";
var currentlyFetching = {};
export var actions = {
    load: function (_a, _b) {
        var commit = _a.commit, rootState = _a.rootState, state = _a.state;
        var slug = _b.slug, _c = _b.type, type = _c === void 0 ? 'pages' : _c, _d = _b.embed, embed = _d === void 0 ? false : _d, _e = _b.fields, fields = _e === void 0 ? [] : _e, _f = _b.beforeSave, beforeSave = _f === void 0 ? null : _f, _g = _b.beforeRequest, beforeRequest = _g === void 0 ? null : _g, _h = _b.beforeSaveFailed, beforeSaveFailed = _h === void 0 ? null : _h;
        return __awaiter(this, void 0, void 0, function () {
            var config, typeBaseUrl, prefix, embedString, halfBase, base, _i, _j, field, requestUrl_1, _k, requestUrl, _l, response, data, _m, err_1, data, _o;
            return __generator(this, function (_p) {
                switch (_p.label) {
                    case 0:
                        config = rootState[ModulePrefix + "_config"];
                        typeBaseUrl = "/wp-json/wp/v2/" + type;
                        if (config.requestPrefix &&
                            config.requestPrefix.length > 0) {
                            prefix = config.requestPrefix;
                            if (prefix.endsWith("/")) {
                                prefix = prefix.substring(0, -1);
                            }
                            if (prefix.startsWith("/")) {
                                prefix = prefix.substr(1);
                            }
                            typeBaseUrl = "/" + prefix + typeBaseUrl;
                        }
                        embedString = embed ? "_embed" : "";
                        halfBase = config.url.endsWith("/")
                            ? config.url.substr(0, config.url.length - 1) + typeBaseUrl
                            : config.url + typeBaseUrl;
                        base = slug === ""
                            ? "" + halfBase + (embedString ? "?" + embedString : embedString)
                            : halfBase + "?slug=" + slug + (embedString ? "&" + embedString : embedString);
                        if (!!fields && !!fields.length) {
                            for (_i = 0, _j = (Array.isArray(fields) ? fields : [fields]); _i < _j.length; _i++) {
                                field = _j[_i];
                                base += "&_fields[]=" + field;
                            }
                        }
                        if (!!fields.length && !fields.includes('slug')) {
                            base += '&_fields[]=slug';
                        }
                        _p.label = 1;
                    case 1:
                        _p.trys.push([1, 16, , 20]);
                        if (!(!state.types[type] || !state.types[type][slug])) return [3 /*break*/, 14];
                        if (currentlyFetching && !currentlyFetching[type]) {
                            currentlyFetching[type] = [];
                        }
                        if (!(currentlyFetching && currentlyFetching[type] && currentlyFetching[type][slug])) return [3 /*break*/, 6];
                        if (!config.debugger) return [3 /*break*/, 5];
                        if (!beforeRequest) return [3 /*break*/, 3];
                        return [4 /*yield*/, beforeRequest(base)];
                    case 2:
                        _k = _p.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        _k = base;
                        _p.label = 4;
                    case 4:
                        requestUrl_1 = _k;
                        console.log("[VueWordpress][Debugger] Omits " + requestUrl_1 + " because it is being fetched currently");
                        _p.label = 5;
                    case 5: return [2 /*return*/];
                    case 6:
                        if (!beforeRequest) return [3 /*break*/, 8];
                        return [4 /*yield*/, beforeRequest(base)];
                    case 7:
                        _l = _p.sent();
                        return [3 /*break*/, 9];
                    case 8:
                        _l = base;
                        _p.label = 9;
                    case 9:
                        requestUrl = _l;
                        return [4 /*yield*/, axios.get(requestUrl)];
                    case 10:
                        response = _p.sent();
                        if (!currentlyFetching[type].includes(slug)) {
                            currentlyFetching[type].push(slug);
                        }
                        if (config.debugger) {
                            console.log("[VueWordpress][Debugger] I've just fetched " + base);
                        }
                        if (response.data.status == 404) {
                            throw new Error("[VueWordpress] Error 404 in " + base + " endpoint");
                        }
                        if (response.data.length < 1) {
                            throw new Error("[VueWordpress] Empty data in " + base + " endpoint");
                        }
                        currentlyFetching[type] = currentlyFetching[type].filter(function (currentSlug) { return currentSlug !== slug; });
                        if (!beforeSave) return [3 /*break*/, 12];
                        return [4 /*yield*/, beforeSave(response.data)];
                    case 11:
                        _m = _p.sent();
                        return [3 /*break*/, 13];
                    case 12:
                        _m = response.data;
                        _p.label = 13;
                    case 13:
                        data = _m;
                        if (config.debugger && data.some(function (page) { return !page.slug; })) {
                            console.log("[VueWordpress][Debugger] Some fetched page does not have slug inside. It will cause problem with saving");
                        }
                        commit(types.SET_POST_CONTENT, {
                            data: data,
                            slotName: slug,
                            type: type
                        });
                        return [3 /*break*/, 15];
                    case 14:
                        if (config.debugger) {
                            console.log("[VueWordpress][Debugger] Did not fetch " + base + " because it is yet in the store");
                        }
                        _p.label = 15;
                    case 15: return [3 /*break*/, 20];
                    case 16:
                        err_1 = _p.sent();
                        currentlyFetching[type] = currentlyFetching[type].filter(function (currentSlug) { return currentSlug !== slug; });
                        if (config.debugger) {
                            console.log("[VueWordpress][Debugger] Could not fetch because of error", err_1);
                        }
                        if (!beforeSaveFailed) return [3 /*break*/, 18];
                        return [4 /*yield*/, beforeSaveFailed()];
                    case 17:
                        _o = _p.sent();
                        return [3 /*break*/, 19];
                    case 18:
                        _o = false;
                        _p.label = 19;
                    case 19:
                        data = _o;
                        commit(types.SET_POST_CONTENT, {
                            data: data,
                            slotName: slug,
                            type: type
                        });
                        return [3 /*break*/, 20];
                    case 20: return [2 /*return*/];
                }
            });
        });
    }
};
//# sourceMappingURL=actions.js.map